/* Object definition which stores preferences */
/* these include:
	- zipCode (which can be a query as well)
	- preferred units
	- drawer state (photos or forecast)
	- widget state (0,1, or 2; 0 being the smallest and 2 being full with the drawer drawn out)
	- rightContent state (radar or current conditions)
	- localWxStnType (airport or PWS)
	- localWxStnId (either ICAO or PWS number)

	Note: when instantiated, the preference object will auto-fill the 'zip' text box
*/

var prefs;

function TESTPreferences() {
	this.url = this.niceUrl = "/US/CA/San_Francisco.html";
	this.units = 0;
	this.drawerState = "forecast";
	this.drawerStateOpen = 'closed';
	this.widgetState = 'minimized';
	this.rightContentState = 'radar';
	this.PWSId = 'KCASANFR14';
	this.airportId = 'KSFO';
	this.photoFeed = "waterfalls_photos.xml";
	this.webcam;
	loc = {"city":"San Francisco","state":"CA","country":"US","wuiurl":"http://www.wunderground.com/US/CA/San_Francisco.html","radar":{"image":"http://resize.wunderground.com/cgi-bin/resize_convert?ox=gif&url=radblast/cgi-bin/radar/WUNIDS_composite%3Fcenterlat=37.77500916%26centerlon=-122.41825867%26radius=15%26newmaps=1%26smooth=1%26num=5%26width=130%26height=130&width=130&height=130","url":"http://www.wunderground.com/radar/radblast.asp?ID=MUX&region=c1&lat=37.77500916&lon=-122.41825867"},"webcams":[{"url":"http://icons.wunderground.com/webcamramdisk/w/u/WunderYakuza/1/widget.jpg?time=1184794669","camUrl":"http://www.wunderground.com/webcams/WunderYakuza/1/show.html","city":"San Francisco","state":"CA","country":"US","organization":"The Weather Underground","handle":"WunderYakuza"},{"url":"http://icons.wunderground.com/webcamramdisk/a/d/admin/1/widget.jpg?t=1184794680&time=1184794669","camUrl":"http://www.wunderground.com/webcams/admin/1/show.html","city":"San Francisco","state":"CA","country":"US","organization":null,"handle":"admin"},{"url":"http://icons.wunderground.com/webcamramdisk/c/h/Chris/1/widget.jpg?t=1184794680&time=1184794669","camUrl":"http://www.wunderground.com/webcams/Chris/1/show.html","city":"Healdsburg","state":"CA","country":"US","organization":"Weather Underground","handle":"Chris"},{"url":"http://icons.wunderground.com/webcamramdisk/s/f/sfweather/1/widget.jpg?t=1184794680&time=1184794669","camUrl":"http://www.wunderground.com/webcams/sfweather/1/show.html","city":"San Francisco","state":"CA","country":"US","organization":null,"handle":"sfweather"}]};
	this.loc = loc;
	this.location = "San Francisco";
	this.subLocation = "China Basin Landing";
	this.loc;
	this.query = "San Francisco, CA";
	
	this.getUrl = function () {
		return this.url;
	};
	this.setUrl = function (str) {
		this.url = str;
	};
	this.getNiceUrl = function () {
		return this.url;
	};
	this.setNiceUrl = function (str) {
		this.url = str;
	};
	this.getQuery = function () {
		return this.query;
	};
	this.setQuery = function (qry) {
		this.query = qry;
	};
	
	this.getUnits = function ()
	{
		return this.units;
	};
	this.setUnits = function(str) {
		this.units = str;
		$('unitSelector').selectedIndex = str;
	};
	
	this.getDrawerState = function () {
		return this.drawerState;
	};
	this.setDrawerState = function (str) {
		this.drawerState = str;
	};
	this.getDrawerStateOpen = function () {
		return this.drawerStateOpen;
	};
	this.setDrawerStateOpen = function (str) {
		this.drawerStateOpen = str;
	};
	
	this.getWidgetState = function () {
		return this.widgetState;
	};
	this.setWidgetState = function (str) {
		this.widgetState = str;
	};
	
	this.getRightContentState = function () {
		return this.rightContentState;
	};
	this.setRightContentState = function (str) {
		this.rightContentState = str;
	};	

	this.getPWSId = function () {
		return this.PWSId;
	};
	this.setPWSId = function (str) {
		this.PWSId = str;
	};

	this.getAirportId = function () {
		return this.airportId;
	};
	this.setAirportId = function (str) {
		this.airportId = str;
	};
	this.getPhotoFeed = function () {
		return this.photoFeed;
	};
	this.setPhotoFeed = function (str) {
		this.photoFeed = str;
	};
	this.getLocation = function () {
		return this.location;
	};
	this.setLocation = function (str) {
		this.location = str;
		$('location').innerHTML = str;
	};
	this.getSubLocation = function () {
		return this.subLocation;
	};
	this.setSubLocation = function (str) {
		this.subLocation = str;
		$('sub-location').innerHTML = str;
	};
	this.getLoc = function() {
		return this.loc;
	};
	this.setLoc = function(str) {
		this.loc = str;
	};
  this.getWebcam = function () {
    return this.webcam;
  };
	this.setWebcam = function(str) {
	  this.webcam = str;
	};

}