var CurCond_TIMEOUT = 10000;
var CurCond_curCondData;

function CurCond_retrieve(type, no_overwrite, callback, error_loading) {
  var url = CurCond_createURL(type);
  var hasBeenLoaded = false;
  
  var request = newXMLHttpRequest();
  if (!request) {if (error_loading) {error_loading();} return;}
  request.onreadystatechange = onReadyStateChange;
  if (request.overrideMimeType) request.overrideMimeType('text/xml');
  request.open("GET", url, true);
  request.setRequestHeader("Cache-Control", "no-cache");
  
  var requestTimeout = view.setTimeout(function() { request.abort(); if (error_loading) {error_loading();}}, CurCond_TIMEOUT);   
  
  request.send();

  function onReadyStateChange() {
    if (request.readyState != 4 || hasBeenLoaded == true) {
      return;
    }
    hasBeenLoaded = true;
	  
    view.clearTimeout(requestTimeout);
    
    if (request.status == 200) {
			debug.trace("CurCond_parseData loaded ");
      CurCond_parseData(request.responseXML, no_overwrite, type, callback, error_loading);
    } else {
      if (error_loading) {
        error_loading(); 
      } 
    }
  }
}

function CurCond_createURL(type) {
	var id;
	var url;
		
	if (type == 'pws') {
		id = prefs.getPWSId();
		url = "http://api.wunderground.com/weatherstation/WXCurrentObXML.asp?ID=" + escape(id);
	} else if (type == 'airport') {
		id = prefs.getAirportId();
		url = "http://api.wunderground.com/auto/wui/geo/WXCurrentObXML/index.xml?query=" + escape(id);
	} else {
		return false;
	}
	return url;
}

function CurCond_parseData(xml, no_overwrite, type, callback, error_loading) {

	try {
	curConds = new Object();	
	var cur_obs = findChild(xml,"current_observation");
	
	curConds.conditions_full = findChildData(cur_obs,"weather");
	curConds.icon = findChildData(cur_obs,"icon");
	
	curConds.wind = [
		findChildData(cur_obs,"wind_mph"),
		toKph(findChildData(cur_obs,"wind_mph"))
	];
	curConds.windDirection = findChildData(cur_obs,"wind_dir");
	
	curConds.windchill = [
		findChildData(cur_obs,"windchill_f"),
		findChildData(cur_obs,"windchill_c")
	];
	
	curConds.heatindex = [
		findChildData(cur_obs,"heat_index_f"),
		findChildData(cur_obs,"heat_index_c")
	];
	
	curConds.humidity = findChildData(cur_obs,"relative_humidity");
	if (curConds.humidity && curConds.humidity.indexOf('%') == -1)
		curConds.humidity += "%";
	
	curConds.dewpoint = [
		findChildData(cur_obs,"dewpoint_f"),
		findChildData(cur_obs,"dewpoint_c")
	];

	curConds.visibility = [
		findChildData(cur_obs,"visibility_mi"),
		findChildData(cur_obs,"visibility_km")
	];

	curConds.temperature = [
		findChildData(cur_obs,"temp_f"),
		findChildData(cur_obs,"temp_c")
	];
	
	curConds.pressure = [
		findChildData(cur_obs,"pressure_in"),
		findChildData(cur_obs,"pressure_mb")
	];
	} catch(e) {
		debug.error("CurCond_parseData: " + e.message);
		if (error_loading) {
			error_loading();
		}
	}
	
	if (no_overwrite == false) {
	  CurCond_curCondData = curConds;
	} else {
	  CurCond_curCondData = new Object();
	}
	
	if (callback) callback(curConds, no_overwrite, type);
}
function CurCond_errorLoading() {
  CurCond_curCondData = null;
	debug.error("CurCond_errorLoading: connection problem");
}
