Photos_TIMEOUT = 10000;
Photos_loaded = false;

function Photos_retrieve(feed, callback, error_loading) {
	if (!feed) {
		if (!(feed = prefs.getPhotoFeed()))	{
			feed = "approvers_choice_photos.xml"; //default feed
		}
	}
  var url = "http://www.wunderground.com/wximage_php/log_xml.php?file=" + feed;
  var hasBeenLoaded = false;

  prefs.setPhotoFeed(feed);
  Photos_setPhotoFeedTitle(feed);  
  Photos_loaded = true;

  var request = newXMLHttpRequest();
  if (!request) {if (error_loading) {error_loading();} return;}
  request.onreadystatechange = onReadyStateChange;
  if (request.overrideMimeType) request.overrideMimeType('text/xml');
  request.open("GET", url, true);
  request.setRequestHeader("Cache-Control", "no-cache");
  
  var requestTimeout = view.setTimeout(function() { request.abort(); if (error_loading) {error_loading();}}, Photos_TIMEOUT);   
  
  request.send();

  function onReadyStateChange() {
    if (request.readyState != 4 || hasBeenLoaded == true) {
      return;
    }
	  hasBeenLoaded = true;
	  
    view.clearTimeout(requestTimeout);
    
    if (request.status == 200) {
			debug.trace("Photos_parseData loaded");
      Photos_parseData(request.responseXML, callback, error_loading);
    } else {
      if (error_loading) {
        error_loading(); 
      } 
    }
  }
}

function Photos_parseData(xml, callback, error_loading) {

	try {
	var photos = new Array();
	
	var weatherPhotos = findChild(xml,"WEATHERPHOTOS");
	var photosArray = weatherPhotos.getElementsByTagName("PHOTO");
	
	//limit to 30 photos
	for (var i = 0; i < photosArray.length && i < 30; i++) {
		var photoNode = photosArray.item(i);
		var photo = new Object();
		
		photo.url = "http://photos.wunderground.com";
		photo.url += findChildData(photoNode,"URL");
		photo.thumbUrl = "http://photos.wunderground.com";
		photo.thumbUrl += findChildData(photoNode,"THUMB_URL");
		photo.linkUrl = "http://www.wunderground.com";
		photo.linkUrl += findChildData(photoNode,"WUI_URL");
		
		photo.width = findChildData(photoNode,"WIDTH");
		photo.height = findChildData(photoNode,"HEIGHT");
		photo.title = findChildData(photoNode,"TITLE");
		photo.number = findChildData(photoNode,"NUMBER");
		photo.handle = findChildData(photoNode,"HANDLE");
		photo.city = findChildData(photoNode,"CITY");
		photo.state = findChildData(photoNode,"STATE");	
		photo.country = findChildData(photoNode,"COUNTRY");
		photo.caption = findChildData(photoNode,"CAPTION");
	
		photos.push(photo);
	}
	} catch(e) {
		debug.error("Photos_parseData: " + e.message);
		if (error_loading) {
			error_loading();
		}
	}
	
	if (callback) callback(photos);
}
function Photos_errorLoading() {
	debug.error("Photos_errorLoading: connection problem");
}