/* General purpose functions */

function newXMLHttpRequest() {
// we first try to use ActiveX, because IE7 has a direct support for XmlHttpRequest object, 
// but which doesn't work with file urls
 var req = false;
 if(view.ActiveXObject)
 {
  try { req = new ActiveXObject("Msxml2.XMLHTTP");
  } catch(e) {
   try { req = new ActiveXObject("Microsoft.XMLHTTP");
   } catch(e) { req = false; }
  }
 }
 else if(view.XMLHttpRequest) {
  try { req = new XMLHttpRequest();
  } catch(e) { req = false; }
 }

 return req; 
}


function hide(id) {document.getElementById(id).style.visibility = "hidden";}
function show(id) {document.getElementById(id).style.visibility = "visible";}

function findChild (element, nodeName) {
	var child;	
	if (!element) {return null;}
	for (child = element.firstChild; child != null; child = child.nextSibling)
	{if (child.nodeName == nodeName) return child;}
	return null;
}
function findChildList(element,listName) {
	var list;
	var returnList = new Array();
	if (!element) {return null;}
	if (typeof element.getElementsByTagName != 'undefined') {
	    list = element.getElementsByTagName(listName);
		  for (var i = 0; i < list.length; i++)
			returnList.push(list.item(i));
		return returnList;
	}
	return null;
}

function findChildData(element,nodeName) {
	var ele = findChild(element,nodeName);
	if (ele != null && ele.hasChildNodes())
		return ele.firstChild.data;
	else
		return null;
}

function $() {
	var elements = new Array();
	for (var i = 0; i < arguments.length; i++) {
		var element = arguments[i];
		if (typeof element == 'string')
			element = document.getElementById(element);
		if (arguments.length == 1)
			return element;
		elements.push(element);
	}
	return elements;
}

function toKph(num) {return Math.round(1.609344*num);}
function toRad(num) {  // convert degrees to radians
  return num * Math.PI / 180;
}

function getDistance(lat1, lon1, lat2, lon2) {
  var R = 6371; // earth's mean radius in km
  var d = Math.acos(Math.sin(toRad(lat1))*Math.sin(toRad(lat2)) +
                    Math.cos(toRad(lat1))*Math.cos(toRad(lat2))*Math.cos(toRad(lon2-lon1))) * R;
  return d;
}

//sort by distance functions
function sortByDistance(a,b) {
	if (Number(a.distance_km) == Number(b.distance_km)) return 0;
	return (Number(a.distance_km) < Number(b.distance_km) ? -1 : 1);
}

//commmon functions
function getStyle(ele,property) {
	var computedStyle = document.defaultView.getComputedStyle(ele, null);
	// Safari returns null from computed style if the display of the element is none
	// if this is the case, then we just return 'none' if the user is asking for the
	// 'display' property, or we temporarily set the display to 'block' and re-fetch
	// the computed style
	var style;
	if (computedStyle != null) {
		style = computedStyle.getPropertyValue(property);
	} else if (property == 'display') {
		style = 'none';
	} else {
		var oldDisplay = ele.style.display;
		ele.style.display = "block";
		computedStyle = document.defaultView.getComputedStyle(ele, null);
		style = computedStyle && computedStyle.getPropertyValue(property) || '';
		ele.style.display = oldDisplay;
	}
	return style;
}

function inArray(value,array) {
	for (var i=0; i < array.length; i++) {
		if (array[i] === value) {
			return true;
		}
	}
	return false;	
}

function indexOfValue(value,array) {
	for (var i=0; i < array.length; i++) {
		if (array[i].value === value) {
			return i;
		}
	}
	return false;	
}

function toCapitalCase(str) {
if (str != null) {
	var re = /\s/;
	var words = str.split(re);
	re = /(\S)(\S+)/;
	for (i = words.length - 1; i >= 0; i--) {
	re.exec(words[i]);
	words[i] = RegExp.$1.toUpperCase()
	+ RegExp.$2.toLowerCase();
	}
	return words.join(' ');
} else {
	return "";
}
}

function addLoadEvent(func) {
	var oldonload = view.onload;
	if (typeof view.onload != 'function') {
		view.onload = func;
	}
	else {
		view.onload = function() {
			oldonload();
			func();
		};
	}
}

function addEvent(elm, evType, fn, useCapture) {
	if (elm.addEventListener) {
		elm.addEventListener(evType, fn, useCapture);
		return true;
	}
	else if (elm.attachEvent) {
		var r = elm.attachEvent('on' + evType, fn);
		return r;
	}
	else {
		elm['on' + evType] = fn;
	}
}
function removeEvent( obj, type, fn ) {
  if ( obj.detachEvent ) {
    obj.detachEvent( 'on'+type, obj[type+fn] );
    obj[type+fn] = null;
  } else
    obj.removeEventListener( type, fn, false );
}

function move(id,left,top) {
	//assume this is in absolute positioning
	var ele = $(id);
	var top = parseInt(document.defaultView.getComputedStyle(ele, null).getPropertyValue("top"),10) + top;
	var left = parseInt(document.defaultView.getComputedStyle(ele, null).getPropertyValue("left"),10) + left;
	ele.style.top = top + "px";
	ele.style.left = left + "px";
}
function put(ele,left,top) {
	ele.style.top = top + "px";
	ele.style.left = left + "px";	
}

function getCookie( name ) {
	var start = document.cookie.indexOf( name + "=" );
	var len = start + name.length + 1;
	if ( ( !start ) && ( name != document.cookie.substring( 0, name.length ) ) ) {
		return null;
	}
	if ( start == -1 ) return null;
	var end = document.cookie.indexOf( ';', len );
	if ( end == -1 ) end = document.cookie.length;
	return unescape( document.cookie.substring( len, end ) );
}

function setCookie( name, value, expires, path, domain, secure ) {
	var today = new Date();
	today.setTime( today.getTime() );
	if ( expires ) {
		expires = expires * 1000 * 60 * 60 * 24;
	}
	var expires_date = new Date( today.getTime() + (expires) );
	document.cookie = name+'='+escape( value ) +
		( ( expires ) ? ';expires='+expires_date.toGMTString() : '' ) + //expires.toGMTString()
		( ( path ) ? ';path=' + path : '' ) +
		( ( domain ) ? ';domain=' + domain : '' ) +
		( ( secure ) ? ';secure' : '' );
}

function deleteCookie( name, path, domain ) {
	if ( getCookie( name ) ) document.cookie = name + '=' +
			( ( path ) ? ';path=' + path : '') +
			( ( domain ) ? ';domain=' + domain : '' ) +
			';expires=Thu, 01-Jan-1970 00:00:01 GMT';
}